<template>
  <div class="container">
    <div class="row">
      <div class="form-group col-md-4">
        <label class="control-label">
          ¿ Tiene fideicomisos ?
        </label>
        <p-radio class="d-inline-block" v-model="bandera" label="1">Si</p-radio>
        <p-radio class="d-inline-block" v-model="bandera" label="0">No</p-radio>
      </div>
    </div>
    <div v-if="bandera == '1'">
      <div v-if="add_item">
        <div class="row">
          <legend>Bienes Intangibles</legend>
        </div>
        <div class="row">
          <div class="form-group col-md-4">
            <label class="control-label">Tipo de Operación</label>
            <el-select  clearable class="select-default" placeholder="Seleccione una opción" v-model="item_bienes.tipo_operacion_id">
              <el-option v-for="option in operaciones" class="select-default" :value="option.id" :label="option.valor" :key="option.label"></el-option>
            </el-select>
          </div>
          <div class="form-group col-md-4" v-if=" item_bienes.tipo_operacion_id == 4">
            <label class="control-label">Especificar tipo operación</label>
            <input class="form-control" type="text" v-model="item_bienes.tipo_operacion_especificar" placeholder="Especificar operación">
          </div>

          <div class="form-group col-md-4">
            <label class="control-label">Propietario registrado</label>
            <input class="form-control" type="text" v-model="item_bienes.propietario_registrado" placeholder="Propietario registrado">
          </div>

          <div class="form-group col-md-4">
            <label class="control-label">Descripción</label>
            <input class="form-control" type="text" v-model="item_bienes.descripcion" placeholder="Descripción">
          </div>

          <div class="form-group col-md-4">
            <label class="control-label">Ente Público encargado del registro (si aplica)</label>
            <el-select  clearable class="select-default" placeholder="Seleccione una opción" v-model="item_bienes.ente_publico_encargado_id">
              <el-option v-for="option in entes" class="select-default" :value="option.id" :label="option.valor" :key="option.label"></el-option>
            </el-select>
          </div>

          <div class="form-group col-md-4">
            <label class="control-label">Número de registro (si aplica)</label>
            <input class="form-control" type="text" v-model="item_bienes.numero_registro" placeholder="Número de registro">
          </div>

          <div class="form-group col-md-4">
            <label class="control-label">Fecha de registro (si aplica)</label>
            <el-date-picker v-model="item_bienes.fecha_registro" type="date" placeholder="Seleccione fecha" value-format="dd-MM-yyyy" format="dd-MM-yyyy"></el-date-picker>
          </div>

          <div class="form-group col-md-4">
            <label class="control-label">Sector / Industria (si aplica)</label>
            <el-select  clearable class="select-default" placeholder="Seleccione una opción" v-model="item_bienes.sector_industria_id">
              <el-option v-for="option in sectores" class="select-default" :value="option.id" :label="option.valor" :key="option.label"></el-option>
            </el-select>
          </div>

          <div class="form-group col-md-4 customCurrency">
            <label class="control-label">Precio de adquisición</label>
            <b-input-group size="sm" :prepend="getSigno">
              <b-form-input type="number" class="text-right" v-model="item_bienes.precio_adquisicion_valor" placeholder="0" @keyup.native="isNumber" />
              <b-dropdown right split :text="getCodigoMoneda" v-model="item_bienes.precio_adquisicion_moneda_id">
                <b-dropdown-item v-for="option in monedas" :key="option.codigo" :value="option.codigo" @click="item_bienes.precio_adquisicion_moneda_id = option.id">{{option.moneda}}</b-dropdown-item>
              </b-dropdown>
            </b-input-group>
          </div>

          <div class="form-group col-md-4">
            <label class="control-label">Forma de adquisición</label>
            <el-select  clearable class="select-default" placeholder="Forma de adquisición" v-model="item_bienes.forma_adquisicion_id">
              <el-option v-for="option in adquisiciones" class="select-default" :value="option.id" :label="option.valor" :key="option.label"></el-option>
            </el-select>
          </div>
          <div class="form-group col-md-4" v-if="item_bienes.forma_adquisicion_id == 8">
            <label class="control-label">Especificar forma de adquisición</label>
            <input class="form-control" type="text" v-model="item_bienes.forma_especificar" placeholder="Especificar">
          </div>

          <div class="form-group col-md-4">
            <label class="control-label">Fecha de vencimiento (si aplica)</label>
            <el-date-picker v-model="item_bienes.fecha_vencimiento" type="date" placeholder="Seleccione fecha" value-format="dd-MM-yyyy" format="dd-MM-yyyy"></el-date-picker>
          </div>

          <div class="form-group col-md-4">
            <label class="control-label">Porcentaje de propiedad ( % )</label>
            <el-input-number v-model="item_bienes.porcentaje_copropiedad" controls-position="right" :step="5" :min="0" :max="100"></el-input-number>
          </div>

          <div class="form-group col-md-4 customCurrency">
            <label class="control-label">Precio total de adquisición</label>
            <b-input-group size="sm" :prepend="getSignos">
              <b-form-input type="number" class="text-right" v-model="item_bienes.precio_total_copropiedad_valor" placeholder="0" @keyup.native="isNumber" />
              <b-dropdown right split :text="getCodigoMonedas" v-model="item_bienes.precio_total_copropiedad_moneda_id">
                <b-dropdown-item v-for="option in monedas" :key="option.codigo" :value="option.codigo" @click="item_bienes.precio_total_copropiedad_moneda_id = option.id">{{option.moneda}}</b-dropdown-item>
              </b-dropdown>
            </b-input-group>
          </div>

          <div class="form-group col-md-4">
            <label class="control-label">Nombre, denominación o razón social del copropietario (si aplica)</label>
            <input class="form-control" type="text" v-model="item_bienes.nombre_copropietario" placeholder="Nombre, denominación o razón social de quien se adquirió el inmueble:">
          </div>

          <div class="form-group col-md-4">
            <label class="control-label">Porcentaje de propiedad del copropietario (si aplica)</label>
            <el-input-number v-model="item_bienes.porcentaje_propiedad_copropietario" controls-position="right" :step="5" :min="0" :max="100"></el-input-number>
          </div>

          <div class="form-group col">
            <label class="control-label">Observaciones / Comentarios</label>
            <input class="form-control" type="text" v-model="item_bienes.observaciones" placeholder="Observaciones / Comentarios">
          </div>

        </div>

        <div class="row justify-content-end m-3">
          <button class="btn btn-primary" @click.prevent="addItem()">
            <span v-if="edit_item == null">
              <i class="fa fa-plus"></i> Agregar
            </span>

            <span v-else>
              <i class="fa fa-save"></i> Guardar
            </span>
          </button>
          <button class="btn btn-danger ml-3" @click.prevent="cancelEdit()">
            <span>
              <i class="fa fa-times"></i> Cancelar
            </span>
          </button>
        </div>
        <div class="row">
          <hr class="col-md-12 bg-info">
        </div>
      </div>
      <div v-if="!add_item">
        <div class="row justify-content-end m-3">
          <button class="btn btn-primary" @click.prevent="showItem()">
            <span>
              <i class="fa fa-plus"></i> Agregar
            </span>
          </button>
        </div>
        <div class="row mt-3 mb-4">

          <div class="col-sm-12 col-md-12 col-lg-12">
            <b-table id="tbl_bienes_intangibles" responsive hover :items="list_bienes" :fields="fields_list" show-empty>
              <!-- :fields="fields_list" -->
              <template slot="acciones" slot-scope="row" class="actions">
                <b-button size="sm" @click.prevent="editItem(row)" class="edit mr-2" :disabled="edit_item != null">
                  Editar <i class="fas fa-pencil-alt ml-2"></i>
                </b-button>
                <b-button size="sm" @click.prevent="removeItem(row.index)" class="delete mr-2" :disabled="edit_item != null">
                  Eliminar <i class="fas fa-trash-alt ml-2"></i>
                </b-button>
              </template>
              <template slot="empty">
                <h5>No existen registros</h5>
              </template>

              <template slot="forma_adquisicion_id" slot-scope="row">{{getFormaAdquisicion(row.item.forma_adquisicion_id)}}</template>
              <template slot="precio_adquisicion_valor" slot-scope="row" class="text-right">{{(getSignoDos(row.item.precio_adquisicion_moneda_id))}}
                {{row.item.precio_adquisicion_valor | currency}}</template>
              <template slot="precio_adquisicion_moneda_id" slot-scope="row" class="text-center">
                {{getMoneda(row.item.precio_adquisicion_moneda_id)}}</template>
              <template slot="precio_total_copropiedad_valor" slot-scope="row" class="text-right">{{(getSignoDos(row.item.precio_total_copropiedad_moneda_id))}}
                {{row.item.precio_total_copropiedad_valor | currency}}</template>
              <template slot="precio_total_copropiedad_moneda_id" slot-scope="row" class="text-center">
                {{getMoneda(row.item.precio_total_copropiedad_moneda_id)}}</template>
              <template slot="tipo_operacion_id" slot-scope="row">{{getOperacion(row.item.tipo_operacion_id)}}</template>
              <template slot="porcentaje_copropiedad" slot-scope="row" class="text-center">{{row.item.porcentaje_copropiedad}} %</template>
              <template slot="porcentaje_propiedad_copropietario" slot-scope="row" class="text-center">{{row.item.porcentaje_propiedad_copropietario}} %</template>
              <template slot="ente_publico_encargado_id" slot-scope="row">{{getEnte(row.item.ente_publico_encargado_id)}}</template>
              <template slot="sector_industria_id" slot-scope="row">{{getSector(row.item.sector_industria_id)}}</template>

            </b-table>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>
<script>
  import {
    Tag,
    Select,
    DatePicker,
    InputNumber
  } from "element-ui";
  import {
    mapFields
  } from "vee-validate";
  export default {
    components: {
      [Tag.name]: Tag,
      [DatePicker.name]: DatePicker,
      [InputNumber.name]: InputNumber
    },
    props: ["data"],
    data() {
      return {
        ip_id: 1,
        add_item: false,
        edit_item: null,
        bandera: '0',
        modelValidations: {
          nombre: {
            min: 5
          },
          email: {
            required: true,
            email: true
          }
        },
        operaciones: null,
        entidadFed: null,
        municipios: null,
        localidades: null,
        localidad: null,
        paises: null,
        monedas: [],
        adquisiciones: [],
        sectores: [],
        entes: [],
        isnum: null,
        /* Lista de fideicomisos */
        item_bienes: {},
        list_bienes: [],
        fields_list: [{
            key: "acciones",
            label: "Acciones",
            tdClass: "text-center"
          },
          {
            key: "tipo_operacion_id",
            label: "Tipo Operacion",
            tdClass: "text-left",
            formatter: 'emptyFields'
          },
          {
            key: "tipo_operacion_especificar",
            label: "Especificar",
            tdClass: "text-left",
            formatter: 'emptyFields'
          },
          {
            key: "propietario_registrado",
            label: "Propietario registrado",
            tdClass: "text-left",
            formatter: 'emptyFields'
          }, ,
          {
            key: "descripcion",
            label: "Descripción",
            tdClass: "text-left",
            formatter: 'emptyFields'
          },
          {
            key: "ente_publico_encargado_id",
            label: "Ente Público encargado del registro",
            tdClass: "text-left",
            formatter: 'emptyFields'
          },
          {
            key: "numero_registro",
            label: "Número de registro",
            tdClass: "text-right",
            formatter: 'emptyFields'
          },
          {
            key: "fecha_registro",
            label: "Fecha de registro",
            tdClass: "text-center",
            formatter: 'emptyFields'
          },
          {
            key: "sector_industria_id",
            label: "Sector / Industria ",
            tdClass: "text-Left",
            formatter: 'emptyFields'
          },
          {
            key: "precio_adquisicion_valor",
            label: "Precio de adquisición ",
            tdClass: "text-right",
            formatter: 'emptyFields'
          },
          {
            key: "precio_adquisicion_moneda_id",
            label: "Moneda",
            tdClass: "text-left",
            formatter: 'emptyFields'
          },
          {
            key: "forma_adquisicion_id",
            label: "Forma de adquisición ",
            tdClass: "text-left",
            formatter: 'emptyFields'
          },
          {
            key: "forma_especificar",
            label: "Especificar",
            tdClass: "text-left",
            formatter: 'emptyFields'
          },
          {
            key: "fecha_vencimiento",
            label: "Fecha de vencimiento ",
            tdClass: "text-center",
            formatter: 'emptyFields'
          },
          {
            key: "porcentaje_copropiedad",
            label: "Porcentaje de propiedad copropiedad",
            tdClass: "text-center",
            formatter: 'emptyFields'
          },
          {
            key: "precio_total_copropiedad_valor",
            label: "Precio total de adquisición copropiedad  ",
            tdClass: "text-right",
            formatter: 'emptyFields'
          },
          {
            key: "precio_total_copropiedad_moneda_id",
            label: "Moneda",
            tdClass: "text-left",
            formatter: 'emptyFields'
          },
          {
            key: "nombre_copropietario",
            label: "Nombre del copropietario ",
            tdClass: "text-left",
            formatter: 'emptyFields'
          },
          {
            key: "porcentaje_propiedad_copropietario",
            label: "Porcentaje de propiedad del copropietario",
            tdClass: "text-center",
            formatter: 'emptyFields'
          },
          {
            key: "observaciones",
            label: "Observaciones",
            tdClass: "text-left",
            formatter: 'emptyFields'
          }
        ]
      };
    },
    computed: {
      getSigno() {
        var signo = "$";
        var val = this.item_bienes.precio_adquisicion_moneda_id;
        this.monedas.forEach(function (item) {
          if (item.id == val) {
            signo = item.signo;
          }
        });
        return signo;
      },
      getCodigoMoneda() {
        var codigo = "MXN";
        var val = this.item_bienes.precio_adquisicion_moneda_id;
        this.monedas.forEach(function (item) {
          if (item.id == val) {
            codigo = item.codigo;
          }
        });
        return codigo;
      },
      getSignos() {
        var signo = "$";
        var val = this.item_bienes.precio_total_copropiedad_moneda_id;
        this.monedas.forEach(function (item) {
          if (item.id == val) {
            signo = item.signo;
          }
        });
        return signo;
      },
      getCodigoMonedas() {
        var codigo = "MXN";
        var val = this.item_bienes.precio_total_copropiedad_moneda_id;
        this.monedas.forEach(function (item) {
          if (item.id == val) {
            codigo = item.codigo;
          }
        });
        return codigo;
      },
    },
    watch: {
      list_bienes: {
        handler: function () {
          if (this.list_bienes) {
            if (this.list_bienes.length == 0) {
              this.bandera = '0';
            } else {
              this.bandera = '1';
            }
          }
        },
        deep: true
      },
    },
    methods: {
      getSignoDos(val = "97") {
        var signo = "$";
        this.monedas.forEach(function (item) {
          if (item.id == val) {
            signo = item.signo;
          }
        });
        return signo;
      },
      emptyFields(value) {
        if (value) {
          if (typeof value === 'string' || value instanceof String) {
            return value.toUpperCase();
          } else {
            return value;
          }
        } else {
          return '-';
        }
      },
      getSector(index) {
        var resp = " ";
        if (this.sectores) {
          this.sectores.forEach(function (item) {
            if (item.id == index) {
              resp = item.valor;
              return resp;
            }
          });
        }
        return resp;
      },
      getOperacion(index) {
        var resp = " ";
        if (this.operaciones) {
          this.operaciones.forEach(function (item) {
            if (item.id == index) {
              resp = item.valor;
              return resp;
            }
          });
        }
        return resp;
      },
      getEnte(index) {
        var resp = " ";
        if (this.entes) {
          this.entes.forEach(function (item) {
            if (item.id == index) {
              resp = item.valor;
              return resp;
            }
          });
        }
        return resp;
      },
      getMoneda(index) {
        var resp = "";
        if (this.monedas) {
          this.monedas.forEach(function (item) {
            if (item.id == index) {
              resp = item.moneda;
            }
          });
        }
        return resp;
      },
      getFormaAdquisicion(index) {
        var resp = " ";
        if (this.adquisiciones) {
          this.adquisiciones.forEach(function (item) {
            if (item.id == index) {
              resp = item.valor;
              return resp;
            }
          });
        }
        return resp;
      },
      getMunicipio(index) {
        var resp = "";
        if (this.municipios) {
          this.municipios.forEach(function (item) {
            if (item.id == index) {
              resp = item.nom_mun;
              return resp;
            }
          });
        }
        return resp;
      },
      getEntidad(index) {
        var resp = " ";
        if (this.entidadFed) {
          this.entidadFed.forEach(function (item) {
            if (item.id == index) {
              resp = item.nom_ent;
              return resp;
            }
          });
        }
        return resp;
      },
      getPais(index) {
        var resp = "México";
        if (this.paises) {
          this.paises.forEach(function (item) {
            if (item.id == index) {
              resp = item.valor;
              return resp;
            }
          });
        }
        return resp;
      },
      initItem() {
        this.item_bienes = {
          acciones: "",
          tipo_operacion_id: "",
          tipo_operacion_especificar: "",
          propietario_registrado: "",
          descripcion: "",
          ente_publico_encargado_id: "",
          numero_registro: "",
          fecha_registro: "",
          sector_industria_id: "",
          precio_adquisicion_valor: "",
          precio_adquisicion_moneda_id: 97,
          forma_adquisicion_id: "",
          fecha_vencimiento: "",
          porcentaje_copropiedad: 100,
          precio_total_copropiedad_valor: "",
          precio_total_copropiedad_moneda_id: 97,
          nombre_copropietario: "",
          porcentaje_propiedad_copropietario: 100,
          observaciones: "",
        };
      },
      showItem() {
        this.add_item = !this.add_item;
      },
      cancelEdit() {
        if (this.edit_item) {
          this.edit_item.item._rowVariant = "";
        }
        this.initItem();
        this.showItem();
        this.edit_item = null;
      },
      addItem() {
        if (this.item_bienes) {
          this.item_bienes.ip_id = this.ip_id;
          this.loadButton(this.$refs.btnSave);
          this.$http.post("bienes_intangibles", this.item_bienes).then(
            response => {
              this.StepOk("Guardado");
              if (this.edit_item === undefined || this.edit_item === null) {
                this.list_bienes.push({
                  ...response.data.bien
                });
              } else {
                this.list_bienes.splice(
                  this.edit_item.index,
                  1,
                  this.item_bienes
                );
                this.edit_item.item._rowVariant = "";
              }
              this.initItem();
              this.showItem();
              this.edit_item = null;
            },
            error => {
              this.StepError(error);
              //this.change =  true;
            }
          );
        } else {
          this.StepW("Hay campos sin completar");
        }
        //console.log(this.item_bienes);
      },
      editItem(indice) {
        this.showItem();
        this.edit_item = indice;
        this.item_bienes = {
          ...this.list_bienes[this.edit_item.index]
        };
        this.edit_item.item._rowVariant = "danger";
        $(".main-panel").animate({
            scrollTop: 100
          },
          500,
          "swing"
        );
      },
      removeItem(indice) {
        if (this.list_bienes[indice].id !== null) {
          let item = this.list_bienes[indice];
          this.Ask("Desea borrar este registro", () => {
            this.$http.delete("bienes_intangibles/" + item.id).then(
              response => {
                /* eventBus.$emit("TramiteDelete", item); */
                this.list_bienes.splice(indice, 1);
              },
              error => {
                this.Err(error);
              }
            );
          });
        }
      },
      getError(fieldName) {
        return this.errors.first(fieldName);
      },
      validate() {
        return this.$validator.validateAll();
      },
      isNumber(n) {
        //console.log(n);
        n.target.value = n.target.value.replace(/[^\d.-]/g, '');
      }
    },
    created() {
      this.initItem();
      this.$http.get("bienes_intangibles/" + this.ip_id).then(
        response => {
          this.list_bienes = response.data.bienes;
        },
        error => {
          this.Err(error);
        }
      );
      this.$http.get("cat_tipo_operacion_inversion").then(
        response => {
          this.operaciones = response.data.tipos;
        },
        error => {
          this.Err(error);
        }
      );
      this.$http.get("cat_forma_adquisicion").then(
        response => {
          this.adquisiciones = response.data.adquisiciones;
        },
        error => {
          this.Err(error);
        }
      );
      this.$http.get("monedas").then(
        response => {
          this.monedas = response.data.monedas;
          /* var temp = "97";
          this.monedas.forEach(function (item) {
            if (item.codigo == "MXN") {
              temp = item.id;
            }
          });
          this.item_bienes.precio_adquisicion_moneda_id = temp; */
        },
        error => {
          this.Err(error);
        }
      );
      this.$http.get("cat_sector_industria").then(
        response => {
          this.sectores = response.data.sectores;
        },
        error => {
          this.Err(error);
        }
      );
      this.$http.get("cat_ente_publico").then(
        response => {
          this.entes = response.data.entes_publicos;
        },
        error => {
          this.Err(error);
        }
      );
    }
  };

</script>
<style>


</style>
